-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 5 of the Cloudera Navigator schema. Adds the hive audit table to navigator schema.
--

UPDATE GOV_SCHEMA_VERSION SET VERSION = 5;

create table HIVE_AUDIT_EVENTS (
  ID                       number(19,0) not null,
  EVENT_TIME               number(19,0) not null,
  ALLOWED                  number (1,0) not null,
  SERVICE_NAME             varchar2(255) not null,
  USERNAME                 varchar2(255) not null,
  IP_ADDR                  varchar2(255) not null,
  OPERATION                varchar2(255) not null,
  DATABASE_NAME            varchar2(1024),
  OBJECT_TYPE              varchar2(255),
  TABLE_NAME               varchar2(1024),
  OPERATION_TEXT           varchar2(1024),
  primary key (ID)
);

CREATE INDEX IDX_HIVE_EVENT_TIME ON HIVE_AUDIT_EVENTS (EVENT_TIME);

CREATE SEQUENCE HIVE_AUDIT_EVENTS_SEQUENCE
  START WITH 1
  NOMAXVALUE;
